
#ifndef _include_bleifrei_Base_hpp_
#define _include_bleifrei_Base_hpp_ 


namespace bleifrei {
/*
	template<class T>
	class Reference
	{
	public:
		Reference(const Reference<T> reference);
		Reference(T *object);
		~Reference(void);

		T *operator T *(void);
		T *operator =(T *object);
	private:
		T *m_object;
	};
*/
	template<class T>
	void
	safe_release(T *&object) {
		if (object)
		{
			object->release();
			object = 0;
		}
	}

	class Base
	{
	public:
		Base(void) : referenceCount(0)												{ addReference();					}
		virtual ~Base(void)															{ ;									}

		void addReference(void)														{ ++referenceCount;					}
		void release(void);

		unsigned int getReferenceCount(void) const									{ return referenceCount;			}

	protected:
		unsigned int referenceCount;
	};

}


#endif //_include_bleifrei_Base_hpp_