
#ifndef _include_bleifrei_tex_TextureManager_hpp_
#define _include_bleifrei_tex_TextureManager_hpp_ 


// includes 
#include <map>
#include <string>

#include "../Singleton.hpp"

namespace bleifrei {
	namespace tex {

		class Texture;

		class TextureManager : public Singleton<TextureManager>
		{
			friend class Singleton<TextureManager>;
		public:
			bool init(const std::string &path = "", bool deferredLoading = false);
			void destroy(void);

			Texture *load(const std::string &filename);
		
			void reloadAll(void);
			void performDeferredLoading(void);

			std::string getTextureName(Texture *texture);

		private:
			TextureManager(void);
			~TextureManager(void);

			std::map<std::string, Texture *> m_textures;
			std::string m_texturePath;

			bool m_deferredLoading;
		};

	}
}


#endif //_include_bleifrei_tex_TextureManager_hpp_