
#ifndef _include_global_hpp_
#define _include_global_hpp_ 

#include "bleifrei/math/Matrix.hpp"

#ifndef M_PI
#define M_PI 3.14159265358979323846f
#endif

namespace bleifrei {
	namespace platform {
		class System;
		class Window;
	}
	namespace io {
		class Console;
	}
	namespace input {
		class Keyboard;
		class Mouse;
	}
	namespace tex {
		class TextureManager;
	}
	namespace gfx {
		class EffectManager;
	}
}

class GUI;

extern GUI *g_gui;

extern bleifrei::platform::System		&g_system;
extern bleifrei::io::Console			&g_console;
extern bleifrei::platform::Window		&g_window;
extern bleifrei::input::Keyboard		&g_keyboard;
extern bleifrei::input::Mouse			&g_mouse;
extern bleifrei::tex::TextureManager	&g_textureManager;
extern bleifrei::gfx::EffectManager		&g_effectManager;

extern float g_time;

extern bleifrei::math::Vector3f g_cameraPosition;
extern bleifrei::math::Matrix4x4f g_modelMatrix;
extern bleifrei::math::Matrix4x4f g_projectionMatrix;
extern bleifrei::math::Matrix4x4f g_viewMatrix;

extern int g_width;
extern int g_height;
extern bool g_postprocessing;

extern std::string g_effectFilename;

void setLoadingProgressMax(int max);
void setLoadingText(const std::string &text);
void progressCallback(int progress);

void initRender(void);
void shutdownRender(void);
void initEffect(void);
bool render(void);

#endif //_include_global_hpp_
