
// includes
#include "bleifrei/gfx/opengl.hpp"
#include "bleifrei/tex/Texture.hpp"
#include "bleifrei/tex/TextureManager.hpp"

#include "Window.hpp"

using namespace bleifrei::gfx;
using namespace bleifrei::tex;
using namespace bleifrei;

extern int g_width;
extern int g_height;

Window::Window(int width, int height, int x, int y)
{
	move(x, y);
	resize(width, height);
	calculatePosition(g_width, g_height);
	m_texture = TextureManager::getInstance().load("GUI_window.tga");
}

Window::~Window(void)
{
}

void
Window::onPaintBackground(int absx, int absy)
{
	m_texture->bind();

	glEnable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(1,1,1,1);
	glBegin(GL_QUADS);
	{
		glTexCoord2f(0.0f, 1.0f);
		glVertex2i(absx, absy);
		glTexCoord2f(0.0f, 0.5f);
		glVertex2i(absx, absy + 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + 32, absy + 32);
		glTexCoord2f(0.5f, 1.0f);
		glVertex2i(absx + 32, absy);

		glTexCoord2f(0.5f, 1.0f);
		glVertex2i(absx + 32, absy);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + 32, absy + 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + getWidth() - 32, absy + 32);
		glTexCoord2f(0.5f, 1.0f);
		glVertex2i(absx + getWidth() - 32, absy);

		glTexCoord2f(0.5f, 1.0f);
		glVertex2i(absx + getWidth() - 32, absy);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + getWidth() - 32, absy + 32);
		glTexCoord2f(1.0f, 0.5f);
		glVertex2i(absx + getWidth(), absy + 32);
		glTexCoord2f(1.0f, 1.0f);
		glVertex2i(absx + getWidth(), absy);

		glTexCoord2f(1.0f, 0.5f);
		glVertex2i(absx + getWidth(), absy + getHeight() - 32);
		glTexCoord2f(1.0f, 0.5f);
		glVertex2i(absx + getWidth(), absy + 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + getWidth() - 32, absy + 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + getWidth() - 32, absy + getHeight() - 32);

		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + getWidth() - 32, absy + getHeight() - 32);
		glTexCoord2f(0.5f, 0.0f);
		glVertex2i(absx + getWidth() - 32, absy + getHeight());
		glTexCoord2f(1.0f, 0.0f);
		glVertex2i(absx + getWidth(), absy + getHeight());
		glTexCoord2f(1.0f, 0.5f);
		glVertex2i(absx + getWidth(), absy + getHeight() - 32);

		glTexCoord2f(0.5f, 0.0f);
		glVertex2i(absx + getWidth() - 32, absy + getHeight());
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + getWidth() - 32, absy + getHeight() - 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + 32, absy + getHeight() - 32);
		glTexCoord2f(0.5f, 0.0f);
		glVertex2i(absx + 32, absy + getHeight());

		glTexCoord2f(0.0f, 0.5f);
		glVertex2i(absx, absy + getHeight() - 32);
		glTexCoord2f(0.0f, 0.0f);
		glVertex2i(absx, absy + getHeight());
		glTexCoord2f(0.5f, 0.0f);
		glVertex2i(absx + 32, absy + getHeight());
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + 32, absy + getHeight() - 32);

		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + 32, absy + getHeight() - 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + 32, absy + 32);
		glTexCoord2f(0.0f, 0.5f);
		glVertex2i(absx, absy + 32);
		glTexCoord2f(0.0f, 0.5f);
		glVertex2i(absx, absy + getHeight() - 32);

		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + getWidth() - 32, absy + getHeight() - 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + getWidth() - 32, absy + 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + 32, absy + 32);
		glTexCoord2f(0.5f, 0.5f);
		glVertex2i(absx + 32, absy + getHeight() - 32);
	}
	glEnd();
	glDisable(GL_BLEND);
}